//@STATE=쐬
//@DESCRIPTION ---------------------------------------------------------------
// StartImpl.cpp: StartImpl NX̃Cve[V
// $Log: StartImpl.cpp,v $
// Revision 1.1  2001/10/28 21:40:37  fujiwara
// DLLɕ
//
// Revision 1.5  2001/07/09 20:30:10  fujiwara
// Ȏgݍ
//
// Revision 1.4  2001/07/01 21:30:34  fujiwara
// [N`FbN
//
// Revision 1.3  2001/07/01 01:03:44  fujiwara
// const ̌
// zuGfB^͓ro
//
// Revision 1.2  2001/05/12 00:48:55  fujiwara
// bur𓱓AO\ǉ
//
//@DESCRIPTION_END -----------------------------------------------------------
//@AUTHOR=S.F.
// Copyright (C) 2000 Satoshi Fujiwara. All Rights Reserved.
#pragma warning( disable : 4786 )	//STĽxO
// [[Nop
// [[Nop
#include "sfdebug.h"


#include <stack>
#include <list>
#include <vector>
#include <map>

#include "exception.h"
#include "system.h"
#include "sound.h"
#include "console.h"
#include "Obj.h"
#include "Obj2D.h"
#include "ObjRectangle.h"
#include "ObjQuadrangle.h"
#include "input.h"
#include "Scene.h"
#include "s2001.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#include "main.h"
#include "fade.h" //tF[hCAtF[hAEgV[
#include "AbstractScene.h"
#include "StartImpl.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////
using namespace sf::application::scene;


const int StartImpl::PERIOD = 1000 / sf::system::TIMER_INTERVAL * 3;
const char StartImpl::BGM_FILENAME[sf::system::MAX_PATH_] = "select.sgt";

StartImpl::StartImpl()
{
	mTimer = PERIOD;
	mTimer1 = 0;
	mState = INITIALIZE;
	mpScene = NULL;
}// StartImpl()

StartImpl::~StartImpl()
{
	if(mpScene)
		delete mpScene;
}// ~StartImpl()

// XPW[ ---------------------------------------------------------------
void StartImpl::move(void)
{
	switch(mState)
	{
	case INITIALIZE:
		initialize();
		return;
	case FADE_IN:
		fadeIn();
		return;
	case MAIN:
		main();
		return;
	}
}// move()

//  --------------------------------------------------------------------
void StartImpl::initialize()
{
	Fade* pfade;

	mpSound->load(0,BGM_FILENAME);

	mState = MAIN;
	
	// tF[hCݒ	
	mpScene = scene::createScene(FADE);
	mpScene->addListener(this);

	// tF[hIuWFNgŗLɃANZX
	pfade = dynamic_cast<Fade *>(mpScene);
	pfade->startColor(0xff000000);
	pfade->endColor(0x00000000);
	pfade->speed(0.05f);
	pfade->fadeType(Fade::FADE_IN);
	pfade->fadeVolumeFlag(false);

	mState = FADE_IN;
	sleep();
}// intialize()

//@C |||||||||||||||||||||||||||||||||
bool StartImpl::main()
{
	mTimer --;
	
	if(mpInput->exit(true))
	{
		exitKeyPressed(this);
		return true;
//		return end();
	}

	if(!mTimer){
		return end();
	}

//	mpMain->printPlayerInfo();
	printMessage();
	
	return true;
}// main()

//@I@||||||||||||||||||||||||||||||||
bool StartImpl::end()
{
	callSceneEvent(&Listener::endOfScene);
	delete this;
	return true;
}// end()

// tF[hC ||||||||||||||||||||||||||||||
bool StartImpl::fadeIn()
{
	printMessage();	
	return true;
}// fadeIn()

// tF[hC̏I |||||||||||||||||||||||||||
void StartImpl::endOfScene(Scene *pScene)
{
	switch(mState)
	{
	case FADE_IN:
		// BGM tJn
		active();
		mpSound->play(0,1,true,true);
		mState = MAIN;
		mpScene = NULL;
		break;
	}
}// endOfScene()

// tF[hCɂdwhsL[ꂽI|||||||||||||||||
void StartImpl::exitKeyPressed(Scene *pScene)
{
	callSceneEvent(&Listener::exitKeyPressed);
	delete this;
}// exitKeyPressed()

// X^[gbZ[W̕\ ||||||||||||||||||||||||
void StartImpl::printMessage()
{
	using namespace sf::system::console;

	mTimer1 ++;

	// X^[guN\
	if(mTimer1 & 0x8)
	{
		mpConsole->print(
			0,
			viewport::X + viewport::WIDTH / 2.0f - 12.0f / 2.0f * text::COLUMN_PITCH,
			viewport::Y + viewport::HEIGHT / 8.0f,
			0.0f,
			1.0f,
			0xffffffff,
			"Game StartImpl!!");
	}

}// printMessage()
